Custom field values for enumerations not saved

2018-05-31 21:55 - Andriy Lesyuk

Status: Closed Start date:  

Priority: Normal Due date:  

Assignee: Jean-Philippe Lang % Done: 0%

Category: Custom fields Estimated time: 0.00 hour

Target version: 3.4.7   

Resolution: Fixed Affected version: 3.4.5

Description

The Enumerations controller drops custom_field_values from params, therefore they are never saved. This is done in the code:

  def enumeration_params

    # can't require enumeration on #new action

    params.permit(:enumeration => [:name, :active, :is_default, :position])[:enumeration]

  end

 Here :custom_field_values is missing.

Steps to reproduce:

1. Add a custom field for activities (time tracking)

2. Edit any activity (time tracking) in Enumerations

3. Try to save a value for the previously created custom field (it won't be saved)

Related issues:

Related to Redmine - Defect #26564: Enumerations sorting does not work Closed

Associated revisions

Revision 17484 - 2018-09-15 08:45 - Jean-Philippe Lang

Custom field values for enumerations not saved (#28925).

Patch by Mizuki ISHIKAWA.

Revision 17485 - 2018-09-15 08:47 - Jean-Philippe Lang

Merged r17484 to 3.4-stable (#28925).

Revision 17488 - 2018-09-15 11:07 - Jean-Philippe Lang

Create fixture correctly.

Revision 17489 - 2018-09-15 11:08 - Jean-Philippe Lang

Merged r17488 to 3.4-stable (#28925).

History

#1 - 2018-06-01 06:35 - Go MAEDA

- Status changed from New to Confirmed

- Priority changed from Low to Normal

- Target version set to Candidate for next minor release

#2 - 2018-06-01 06:41 - Go MAEDA

- Related to Defect #26564: Enumerations sorting does not work added

#3 - 2018-06-18 07:44 - Mizuki ISHIKAWA

- File fix_28925.patch added
I wrote a patch to fix this defect.

The key of custom_field_values allows only id of custom field of enumeration.

#4 - 2018-06-18 08:18 - Mizuki ISHIKAWA

- File fix_28925_v2.patch added

I changed the test a little.

#5 - 2018-06-18 17:38 - Go MAEDA

Maybe we can use available_custom_fields to collect ids of custom fields. I think the following change can make the patch simpler and faster. Mizuki,

do you think it is correct?

--- app/controllers/enumerations_controller.rb.orig    2018-06-18 15:28:18.000000000 +0000

+++ app/controllers/enumerations_controller.rb    2018-06-18 15:28:36.000000000 +0000

@@ -107,7 +107,7 @@

   def enumeration_params

     # can't require enumeration on #new action

-    custom_field_keys = (@enumeration.try(:custom_field_values) || []).map{|c| c.custom_field_id.to_s}

+    custom_field_keys = @enumeration.available_custom_fields.map{|c| c.id.to_s}

     params.permit(:enumeration => [:name, :active, :is_default, :position, :custom_field_values => custom_fie

ld_keys])[:enumeration]

   end

 end

#6 - 2018-06-18 19:54 - Pavel Rosický

why enumerations use strong params instead of safe_attributes like all other models do?

#7 - 2018-06-19 01:45 - Mizuki ISHIKAWA

Go MAEDA wrote:

Maybe we can use available_custom_fields to collect ids of custom fields. I think the following change can make the patch simpler and faster.

Mizuki, do you think it is correct?

[...]

 I did not know available_custom_fields. I think that the code you propose is good.

Pavel Rosický wrote:

why enumerations use strong params instead of safe_attributes like all other models do?

 I do not know the reason, It seems that it was intentionally changed to use strong_params instead of safe_attribute in r16602 and r16603.

#8 - 2018-06-19 02:49 - Go MAEDA

- File fix_28925_v3.patch added

- Target version changed from Candidate for next minor release to 3.4.7

Mizuki ISHIKAWA wrote:

I did not know available_custom_fields. I think that the code you propose is good.

 Thank you for reviewing the change I suggested in #28925#note-5. I have slightly changed your patch.

Setting target version to 3.4.7.

#9 - 2018-09-15 08:48 - Jean-Philippe Lang

- Status changed from Confirmed to Closed

- Assignee set to Jean-Philippe Lang

- Resolution set to Fixed

Committed, thanks.
https://www.redmine.org/projects/redmine/repository/svn/revisions/16602
https://www.redmine.org/projects/redmine/repository/svn/revisions/16603
https://www.redmine.org/issues/28925#note-5


#10 - 2018-09-15 11:09 - Jean-Philippe Lang

Patch broke 3.4-stable, fixed.

Files

fix_28925.patch 2.97 KB 2018-06-18 Mizuki ISHIKAWA

fix_28925_v2.patch 2.99 KB 2018-06-18 Mizuki ISHIKAWA

fix_28925_v3.patch 2.94 KB 2018-06-19 Go MAEDA
